#int atoi(const char*s)
atoi:   addi $sp, $sp, -16   # push ra, s0, s1, s2
        sw   $ra, 0($sp)
        sw   $s0, 4($sp)
        sw   $s1, 8($sp)
        sw   $s2, 12($sp)

        move $s0, $a0        # Save address of s in $s0
        move $s1, $zero      # Initialize size/count to 0

sloop:  add  $t0, $s0, $s1   # Get address of current char
        lb   $s2, 0($t0)     # Get the current char
        move $a0, $s2       
        jal  digit           # Call digit to determine if digit
        beq  $v0, $0, sexit  # If it's not a digit go to exit
        addi $t0, $s2, -48   # Determine distance from '0'
        addi $sp, $sp, -4    
        sw   $t0, 0($sp)     # Push int rep onto stack
        addi $s1, $s1, 1     # Increment counter
        j sloop    

sexit:  move $s0, $zero      # Init running sum to 0 
        li   $s2, 1          # Init place multiplier to 1
        li   $t1, 10         # Store 10 in $t1 for later

cloop:  beq  $s1, $0, cexit  # Exit loop when no more numbers
        lw   $t0, 0($sp)     # Get place value
        mult $t0, $s2   
        mflo $t0             # Mult value by place value
        add  $s0, $s0, $t0   # Add to running sum
        addi $sp, $sp, 4     # Pop value off stack
        addi $s1, $s1, -1    # Decrement counter
        mult $s2, $t1    
        mflo $s2             # Multiply place mult by 10
        j    cloop

cexit:  move $v0, $s0        # Return running sum
        lw   $ra, 0($sp)     # Pop $ra, $s0-$s2
        lw   $s0, 4($sp)
        lw   $s1, 8($sp)
        lw   $s2, 12($sp)
        addi $sp, $sp, 16
        jr   $ra             # Return