.data
expression:
        .asciiz "(4 + 3*(1 + 2 + 3)/(1 + (3/2))) + 2\n"
        
.text
main:   la $a0, expression
        jal eval
        add $a0, $v0, $zero
        
        li $v0, 1
        syscall

        li $v0, 11
        li $a0, 0x0a
        syscall
        
done:   li $v0, 10
        syscall

#int atoi(const char*s)
atoi:   addi $sp, $sp, -16   # push ra, s0, s1, s2
        sw   $ra, 0($sp)
        sw   $s0, 4($sp)
        sw   $s1, 8($sp)
        sw   $s2, 12($sp)

        move $s0, $a0        # Save address of s in $s0
        move $s1, $zero      # Initialize size/count to 0

sloop:  add  $t0, $s0, $s1   # Get address of current char
        lb   $s2, 0($t0)     # Get the current char
        move $a0, $s2       
        jal  digit           # Call digit to determine if digit
        beq  $v0, $0, sexit  # If it's not a digit go to exit
        addi $t0, $s2, -48   # Determine distance from '0'
        addi $sp, $sp, -4    
        sw   $t0, 0($sp)     # Push int rep onto stack
        addi $s1, $s1, 1     # Increment counter
        j sloop    

sexit:  move $s0, $zero      # Init running sum to 0 
        li   $s2, 1          # Init place multiplier to 1
        li   $t1, 10         # Store 10 in $t1 for later

cloop:  beq  $s1, $0, cexit  # Exit loop when no more numbers
        lw   $t0, 0($sp)     # Get place value
        mult $t0, $s2   
        mflo $t0             # Mult value by place value
        add  $s0, $s0, $t0   # Add to running sum
        addi $sp, $sp, 4     # Pop value off stack
        addi $s1, $s1, -1    # Decrement counter
        mult $s2, $t1    
        mflo $s2             # Multiply place mult by 10
        j    cloop

cexit:  move $v0, $s0        # Return running sum
        lw   $ra, 0($sp)     # Pop $ra, $s0-$s2
        lw   $s0, 4($sp)
        lw   $s1, 8($sp)
        lw   $s2, 12($sp)
        addi $sp, $sp, 16
        jr   $ra             # Return

#int digit(char c)
digit:  slti $t0, $a0, 0x30  # Determine if c < '0' should be 0
        li   $t1, 0x39
        slt  $t1, $t1, $a0   # Determine if c > '9' should be 0 
        or   $t0, $t0, $t1   # Or's exps, 1 if out of range

        nor  $v0, $t0, $zero # Flip LSB and set rest to 0
        andi $v0, $v0, 0x00000001

        jr   $ra             # Return

#int eval(char *s)

eval:   addi $sp, $sp, -24   # Push $ra, $s0-$s4
        sw   $ra, 0($sp)
        sw   $s0, 4($sp)
        sw   $s1, 8($sp)
        sw   $s2, 12($sp)
        sw   $s3, 16($sp)
        sw   $s4, 20($sp)

        move $s0, $a0        # Save value of s

        move $s1, $zero
        move $s2, $zero
        move $s3, $s0
fpl:    move $a0, $s3
        li   $a1, 43
        jal  find            # Call find(s, '+')
        li   $t0, -1
        beq  $v0, $t0, pex   # Go to pex if find -1
        add  $s1, $s1, $v0   
        addi $s1, $s1, 1     # Otherwise, increment $s1
        add  $s3, $s0, $s1   # Get beginning of string to 1 past
        j    fpl

pex:    addi $s1, -1
        move $s3, $s0
fmi:    move $a0, $s3
        li   $a1, 45
        jal  find            # Call find(s, '-')
        li   $t0, -1
        beq  $v0, $t0, nex   # Go to nex if find -1
        add  $s2, $s2, $v0   
        addu $s2, $s2, 1     # Otherwise, increment $s2
        add  $s3, $s0, $s2   # Get beginning of string to 1 past
        j    fmi

nex:    addi $s2, -1
        li   $t0, -1
        beq  $s1, $t0, el1   # Goes to else if no +
        beq  $s2, $t0, spp   # Goes to spp if + and no -
        slt  $t1, $s2, $s1   
        bne  $t1, $0,  spp   # Goes to spp if nind < pind
        j    spn             # Else go to spn
el1:    bne  $s2, $t0, spn   # If there is a -, go to spn

        move $s1, $zero
        move $s2, $zero
        move $s3, $s0
fmul:   move $a0, $s3
        li   $a1, 42
        jal  find            # Call find(s, '*')
        li   $t0, -1
        beq  $v0, $t0, mex   # Go to mex if find -1
        add  $s1, $s1, $v0   
        add  $s1, $s1, 1     # Otherwise, increment $s1
        add  $s3, $s0, $s1   # Get beginning of string to 1 past
        j    fmul

mex:    addi $s1, -1
        move $s3, $s0
fdi:    move $a0, $s3
        li   $a1, 47
        jal  find            # Call find(s, '/')
        li   $t0, -1
        beq  $v0, $t0, dex   # Go to dex if find -1
        add  $s2, $s2, $v0   
        addi $s2, $s2, 1     # Otherwise, increment $s2
        add  $s3, $s0, $s2   # Get beginning of string to 1 past
        j    fdi

dex:    addi $s2, $s2, -1
        li   $t0, -1
        beq  $s1, $t0, el2   # Goes to else if no *
        beq  $s2, $t0, spm   # Goes to spm if * and no /
        slt  $t1, $s2, $s1   
        bne  $t1, $0,  spm   # Goes to spm if dind < mind
        j    spd             # Else go to spd
el2:    bne  $s2, $t0, spd   # If there is a /, go to spd
 
        move $a0, $s0
        li   $a1, 40
        jal  find            # Call find for '('
        li   $t1, -1
        beq  $v0, $t1, num   # If there is no '(' go to num
        add  $s0, $s0, $v0   # Move s to start at '('    
        move $a0, $s0        
        jal  mparen          # Get index of ')'
        add  $t0, $s0, $v0   # Abs addr of ')'
        sb   $0,  0($t0)     # Put a null at ')'
        addi $s0, $s0, 1     # Crop '(' off string
        move $a0, $s0
        jal  eval            # Call eval on expression w/out ()
        j    vret            # Go to return  

spm:    add  $t0, $s0, $s1   # Abs addr of '*'
        sb   $0,  0($t0)     # Put null at '*'
        move $a0, $s0
        jal  eval            # Call eval on first half
        move $s2, $v0        # Put result in $s2
        add  $a0, $s0, $s1
        addi $a0, $a0, 1     # Get addr of 1 past '*'
        jal  eval            # Call eval on second half
        move $s3, $v0        # Put result in $s3
        mult $s2, $s3   
        mflo $v0             # Mult the two halves and return it
        j    vret            # Return
         
spd:    add  $t0, $s0, $s2   # Abs addr of '/'
        sb   $0,  0($t0)     # Put null at '/'
        move $a0, $s0
        jal  eval            # Call eval on first half
        move $s3, $v0        # Put result in $s3
        add  $a0, $s0, $s2   
        addi $a0, $a0, 1     # Get addr of 1 past '/'
        jal  eval            # Call eval on second half
        move $s4, $v0        # Put result in $s4
        div  $s3, $s4   
        mflo $v0             # Div the two halves and return it
        j    vret            # Return
         
spp:    add  $t0, $s0, $s1   # Abs addr of '+'
        sb   $0,  0($t0)     # Put null at '+'
        move $a0, $s0
        jal  eval            # Call eval on first half
        move $s2, $v0        # Put result in $s2
        add  $a0, $s0, $s1
        addi $a0, $a0, 1     # Get addr of 1 past '+'
        jal  eval            # Call eval on second half
        move $s3, $v0        # Put result in $s3
        add  $v0, $s2, $s3   # Add the two halves and return it
        j    vret            # Return

spn:    add  $t0, $s0, $s2   # Abs addr of '-'
        sb   $0,  0($t0)     # Put null at '-'
        move $a0, $s0
        jal  eval            # Call eval on fist half
        move $s3, $v0        # Put result in $s3
        add  $a0, $s0, $s2
        addi $a0, $a0, 1     # Get addr of 1 past '-'
        jal  eval            # Call eval on second half
        move $s4, $v0        # Put result in $s4
        sub  $v0, $s3, $s4   # Sub the two halves and return it
        j    vret            # Return

num:    lb   $s1, 0($s0)
        beq  $s1, $0, inv    # If s[0] = null, invalid
        move $a0, $s1        
        jal  digit           # Call digit(s[0])
        bne  $v0, $0, fin    # Go to final eval if it's a digit
        addi $s0, $s0, 1     # Increment s to next index
        j    num             # Loop again

fin:    move $a0, $s0
        jal  atoi            # Call atoi(s)
        j    vret            # Go to return

inv:    li   $v0, -1         # Invalid return -1

vret:   lw   $ra, 0($sp)     # Pop $ra, $s0-$s4
        lw   $s0, 4($sp)
        lw   $s1, 8($sp)
        lw   $s2, 12($sp)
        lw   $s3, 16($sp)
        lw   $s4, 20($sp)
        addi $sp, $sp, 24
        jr   $ra             # Return

#int find(const char *s, char c)
find:   addi $sp, $sp -24    # Push $ra, $s0-$s3
        sw   $ra, 0($sp)
        sw   $s0, 4($sp)
        sw   $s1, 8($sp)
        sw   $s2, 12($sp)
        sw   $s3, 16($sp)
        sw   $s4, 20($sp)

        move $s0, $a0        # Move s address to $s0
        move $s1, $a1        # Move c to $s1
        move $s2, $zero      # Init index to 0
        li   $s3, 40         # Save char value of '('

floop:  add  $t0, $s0, $s2   # Get absolute address
        lb   $s4, 0($t0)     # Get current char
        beq  $s4, $s1, found # If it finds the char, return ind
        beq  $s4, $s3, paren # If it finds '(', skip to ')'
        beq  $s4, $0, null   # If it finds \0, return -1
        addi $s2, $s2, 1     # Increment counter
        j    floop           # Loop again 

found:  move $v0, $s2        # Sets return as index
        j    fret

paren:  move $a0, $t0
        jal  mparen          # Call mparen starting at '('
        add  $s2, $s2, $v0     
        addi $s2, $s2, 1     # Set index to just after ')'
        j floop

null:   li   $v0, -1         # Sets return to -1
        j    fret

fret:   lw   $ra, 0($sp)     # Pop $ra, $s0-$s4
        lw   $s0, 4($sp)
        lw   $s1, 8($sp)
        lw   $s2, 12($sp)
        lw   $s3, 16($sp)
        lw   $s4, 20($sp)
        addi $sp, $sp, 24
        jr   $ra             # Return

#int mparen(char *s)
mparen: addi $sp, $sp, -12   # push ra, s0, s1
        sw   $ra, 0($sp)
        sw   $s0, 4($sp)
        sw   $s1, 8($sp)

        add  $s0, $a0, $zero # save s+1 and a copy of s
        addi $s1, $a0, 1

mpl1:   lb   $t0, ($s1)      # x = *s
        li   $t1, 0x29       # if (*s == ')') goto mpret
        beq  $t0, $t1, mpret
        li   $t1, 0x28       # if (*s == '(') s += mparen(s)
        bne  $t0, $t1, mpl2
        add  $a0, $s1, $zero
        jal  mparen
        add  $s1, $s1, $v0

mpl2:   addi $s1, $s1, 1     # s++
        b    mpl1            # goto mpl1
        
mpret:  sub  $v0, $s1, $s0   # return (s - s_0)
        lw   $ra, 0($sp)     # pop $ra, $s0, $s1
        lw   $s0, 4($sp)
        lw   $s1, 8($sp)
        addi $sp, $sp, 12
        jr   $ra

