#int find(const char *s, char c)
find:   addi $sp, $sp -24    # Push $ra, $s0-$s3
        sw   $ra, 0($sp)
        sw   $s0, 4($sp)
        sw   $s1, 8($sp)
        sw   $s2, 12($sp)
        sw   $s3, 16($sp)
        sw   $s4, 20($sp)

        move $s0, $a0        # Move s address to $s0
        move $s1, $a1        # Move c to $s1
        move $s2, $zero      # Init index to 0
        li   $s3, 40         # Save char value of '('

floop:  add  $t0, $s0, $s2   # Get absolute address
        lb   $s4, 0($t0)     # Get current char
        beq  $s4, $s1, found # If it finds the char, return ind
        beq  $s4, $s3, paren # If it finds '(', skip to ')'
        beq  $s4, $0, null   # If it finds \0, return -1
        addi $s2, $s2, 1     # Increment counter
        j    floop           # Loop again 

found:  move $v0, $s2        # Sets return as index
        j    fret

paren:  move $a0, $t0
        jal  mparen          # Call mparen starting at '('
        add  $s2, $s2, $v0     
        addi $s2, $s2, 1     # Set index to just after ')'
        j floop

null:   li   $v0, -1         # Sets return to -1
        j    fret

fret:   lw   $ra, 0($sp)     # Pop $ra, $s0-$s4
        lw   $s0, 4($sp)
        lw   $s1, 8($sp)
        lw   $s2, 12($sp)
        lw   $s3, 16($sp)
        lw   $s4, 20($sp)
        addi $sp, $sp, 24
        jr   $ra             # Return
